diff --git a/krita/plugins/tools/tool_transform/kis_tool_transform.cc b/krita/plugins/tools/tool_transform/kis_tool_transform.cc
index 7ccc240..56833aa 100644
--- a/krita/plugins/tools/tool_transform/kis_tool_transform.cc
+++ b/krita/plugins/tools/tool_transform/kis_tool_transform.cc
@@ -53,7 +53,7 @@
 #include <kis_cursor.h>
 #include <kis_image.h>
 #include <kis_undo_adapter.h>
-#include <kis_selected_transaction.h>
+#include <kis_transaction.h>
 #include <kis_selection.h>
 #include <kis_filter_strategy.h>
 #include <widgets/kis_cmb_idlist.h>
@@ -73,12 +73,12 @@
 
 namespace
 {
-class TransformCmd : public KisSelectedTransaction
+class TransformCmdData : public KisSelectedTransactionData
 {
 
 public:
-    TransformCmd(KisToolTransform *tool, KisNodeSP node, double scaleX, double scaleY, QPointF translate, double a, KisSelectionSP origSel, QPoint startPos, QPoint endPos);
-    virtual ~TransformCmd();
+    TransformCmdData(KisToolTransform *tool, KisNodeSP node, double scaleX, double scaleY, QPointF translate, double a, KisSelectionSP origSel, QPoint startPos, QPoint endPos);
+    virtual ~TransformCmdData();
 
 public:
     virtual void redo();
@@ -98,8 +98,8 @@ private:
     QPoint m_newPosition;
 };
 
-TransformCmd::TransformCmd(KisToolTransform *tool, KisNodeSP node, double scaleX, double scaleY, QPointF translate, double a, KisSelectionSP origSel, QPoint originalTopLeft, QPoint originalBottomRight)
-        : KisSelectedTransaction(i18n("Transform"), node)
+TransformCmdData::TransformCmdData(KisToolTransform *tool, KisNodeSP node, double scaleX, double scaleY, QPointF translate, double a, KisSelectionSP origSel, QPoint originalTopLeft, QPoint originalBottomRight)
+        : KisSelectedTransactionData(i18n("Transform"), node)
         , m_scaleX(scaleX)
         , m_scaleY(scaleY)
         , m_translate(translate)
@@ -111,11 +111,11 @@ TransformCmd::TransformCmd(KisToolTransform *tool, KisNodeSP node, double scaleX
 {
 }
 
-TransformCmd::~TransformCmd()
+TransformCmdData::~TransformCmdData()
 {
 }
 
-void TransformCmd::transformArgs(double &sx, double &sy, QPointF &translate, double &a) const
+void TransformCmdData::transformArgs(double &sx, double &sy, QPointF &translate, double &a) const
 {
     sx = m_scaleX;
     sy = m_scaleY;
@@ -123,31 +123,45 @@ void TransformCmd::transformArgs(double &sx, double &sy, QPointF &translate, dou
     a = m_a;
 }
 
-KisSelectionSP TransformCmd::origSelection(QPoint &originalTopLeft, QPoint &originalBottomRight) const
+KisSelectionSP TransformCmdData::origSelection(QPoint &originalTopLeft, QPoint &originalBottomRight) const
 {
     originalTopLeft = m_originalTopLeft;
     originalBottomRight = m_originalBottomRight;
     return m_origSelection;
 }
 
-void TransformCmd::redo()
+void TransformCmdData::redo()
 {
-    KisSelectedTransaction::redo();
+    KisSelectedTransactionData::redo();
     layer()->paintDevice()->move(m_newPosition);
 }
 
-void TransformCmd::undo()
+void TransformCmdData::undo()
 {
-    KisSelectedTransaction::undo();
+    KisSelectedTransactionData::undo();
     layer()->paintDevice()->move(m_originalTopLeft);
 }
 
-void TransformCmd::setNewPosition(int x, int y)
+void TransformCmdData::setNewPosition(int x, int y)
 {
     m_newPosition.setX(x);
     m_newPosition.setY(y);
 }
 
+class TransformCmd : public KisTransaction
+{
+public:
+    TransformCmd(KisToolTransform *tool, KisNodeSP node,
+                 double scaleX, double scaleY,
+                 QPointF translate, double a, KisSelectionSP origSel,
+                 QPoint originalTopLeft, QPoint originalBottomRight)
+    {
+        m_transactionData =
+            new TransformCmdData(tool, node, scaleX, scaleY, translate,
+                                 a, origSel, originalTopLeft, originalBottomRight);
+    }
+};
+
 }
 
 KisToolTransform::KisToolTransform(KoCanvasBase * canvas)
@@ -193,10 +207,10 @@ void KisToolTransform::activate(ToolActivation toolActivation, const QSet<KoShap
     if (currentNode() && currentNode()->paintDevice()) {
         image()->undoAdapter()->setCommandHistoryListener(this);
 
-        const TransformCmd * cmd = 0;
+        const TransformCmdData * cmd = 0;
 
         if (image()->undoAdapter()->presentCommand())
-            cmd = dynamic_cast<const TransformCmd*>(image()->undoAdapter()->presentCommand());
+            cmd = dynamic_cast<const TransformCmdData*>(image()->undoAdapter()->presentCommand());
 
         if (cmd == 0) {
             initHandles();
@@ -656,8 +670,9 @@ void KisToolTransform::transform()
     KoUpdaterPtr progress = updater->startSubtask();
 
     // This mementoes the current state of the active device.
-    TransformCmd * transaction = new TransformCmd(this, currentNode(), m_scaleX,
-            m_scaleY, m_translate, m_a, m_origSelection, m_originalTopLeft, m_originalBottomRight);
+    TransformCmd transaction(this, currentNode(), m_scaleX,
+                             m_scaleY, m_translate, m_a, m_origSelection,
+                             m_originalTopLeft, m_originalBottomRight);
 
 
     //Copy the original state back.
@@ -720,7 +735,7 @@ void KisToolTransform::transform()
                 m_oldMatrixList << shape->transformation();
                 m_newMatrixList << shape->transformation()*matrix;
             }
-            KoShapeTransformCommand* cmd = new KoShapeTransformCommand(shapes, m_oldMatrixList, m_newMatrixList, transaction);
+            KoShapeTransformCommand* cmd = new KoShapeTransformCommand(shapes, m_oldMatrixList, m_newMatrixList, transaction.undoCommand());
             cmd->redo();
         }
 
@@ -737,8 +752,7 @@ void KisToolTransform::transform()
 //     // If canceled, go back to the memento
 //     if(worker.isCanceled())
 //     {
-//         transaction->undo();
-//         delete transaction;
+//         transaction.revert();
 //         return;
 //     }
 
@@ -751,20 +765,16 @@ void KisToolTransform::transform()
     // Else add the command -- this will have the memento from the previous state,
     // and the transformed state from the original device we cached in our activated()
     // method.
-    if (transaction) {
-        transaction->setNewPosition(currentNode()->paintDevice()->x(), currentNode()->paintDevice()->y());
-        if (image()->undo())
-            image()->undoAdapter()->addCommand(transaction);
-        else
-            delete transaction;
-    }
-    updater->deleteLater();
+    TransformCmdData* undoCommand = static_cast<TransformCmdData*>(transaction.undoCommand());
+    undoCommand->setNewPosition(currentNode()->paintDevice()->x(), currentNode()->paintDevice()->y());
+    transaction.commit(image()->undoAdapter());
 
+    updater->deleteLater();
 }
 
 void KisToolTransform::notifyCommandAdded(const QUndoCommand * command)
 {
-    const TransformCmd * cmd = dynamic_cast<const TransformCmd*>(command);
+    const TransformCmdData * cmd = dynamic_cast<const TransformCmdData*>(command);
     if (cmd == 0) {
         // The last added command wasn't one of ours;
         // we should reset to the new state of the canvas.
@@ -776,10 +786,10 @@ void KisToolTransform::notifyCommandAdded(const QUndoCommand * command)
 void KisToolTransform::notifyCommandExecuted(const QUndoCommand * command)
 {
     Q_UNUSED(command);
-    const TransformCmd * cmd = 0;
+    const TransformCmdData * cmd = 0;
 
     if (image()->undoAdapter()->presentCommand())
-        cmd = dynamic_cast<const TransformCmd*>(image()->undoAdapter()->presentCommand());
+        cmd = dynamic_cast<const TransformCmdData*>(image()->undoAdapter()->presentCommand());
 
     if (cmd == 0) {
         // The command now on the top of the stack isn't one of ours
diff --git a/krita/sdk/tests/filestest.h b/krita/sdk/tests/filestest.h
index a533dd6..310e03e 100644
--- a/krita/sdk/tests/filestest.h
+++ b/krita/sdk/tests/filestest.h
@@ -77,7 +77,7 @@ void testFiles(const QString& _dirname, const QStringList& exclusions)
             QString id = doc.image()->colorSpace()->id();
             if (id != "GRAYA" && id != "GRAYA16" && id != "RGBA" && id != "RGBA16") {
                 dbgKrita << "Images need conversion";
-                doc.image()->convertTo(KoColorSpaceRegistry::instance()->rgb8());
+                doc.image()->convertImageColorSpace(KoColorSpaceRegistry::instance()->rgb8());
             }
 
             KTemporaryFile tmpFile;
diff --git a/krita/ui/kis_doc2.cc b/krita/ui/kis_doc2.cc
index 63cadb8..5638682 100644
--- a/krita/ui/kis_doc2.cc
+++ b/krita/ui/kis_doc2.cc
@@ -175,20 +175,16 @@ void KisDoc2::slotLoadingFinished() {
 
 void KisDoc2::openExistingFile(const KUrl& url)
 {
-    setUndo(false);
     qApp->setOverrideCursor(Qt::BusyCursor);
     KoDocument::openExistingFile(url);
     qApp->restoreOverrideCursor();
-    setUndo(true);
 }
 
 void KisDoc2::openTemplate(const KUrl& url)
 {
-    setUndo(false);
     qApp->setOverrideCursor(Qt::BusyCursor);
     KoDocument::openTemplate(url);
     qApp->restoreOverrideCursor();
-    setUndo(true);
 }
 
 bool KisDoc2::init()
@@ -207,8 +203,6 @@ bool KisDoc2::init()
     connect(undoStack(), SIGNAL(indexChanged(int)), SLOT(undoIndexChanged(int)));
     Q_CHECK_PTR(m_d->undoAdapter);
 
-    setUndo(true);
-
     m_d->nserver = new KisNameServer(1);
     Q_CHECK_PTR(m_d->nserver);
 
@@ -271,7 +265,6 @@ bool KisDoc2::loadXML(const KoXmlDocument& doc, KoStore *)
         return false;
     }
 
-    setUndo(false);
     Q_ASSERT(m_d->kraLoader == 0);
     m_d->kraLoader = new KisKraLoader(this, syntaxVersion);
 
@@ -321,7 +314,6 @@ bool KisDoc2::completeLoading(KoStore *store)
     m_d->kraLoader = 0;
 
     setModified(false);
-    setUndo(true);
     m_d->image->setUndoAdapter(m_d->undoAdapter);
     m_d->shapeController->setImage(m_d->image);
     m_d->nodeModel->setImage(m_d->image);
@@ -389,15 +381,13 @@ bool KisDoc2::newImage(const QString& name,
 
     qApp->setOverrideCursor(Qt::BusyCursor);
 
-    setUndo(false);
-
     image = new KisImage(m_d->undoAdapter, width, height, cs, name);
     Q_CHECK_PTR(image);
     image->lock();
 
     connect(image.data(), SIGNAL(sigImageModified()), this, SLOT(setModified()));
     image->setResolution(imageResolution, imageResolution);
-    image->setProfile(cs->profile());
+    image->assignImageProfile(cs->profile());
     documentInfo()->setAboutInfo("title", name);
     documentInfo()->setAboutInfo("comments", description);
 
@@ -414,7 +404,6 @@ bool KisDoc2::newImage(const QString& name,
     cfg.defImageHeight(height);
     cfg.defImageResolution(imageResolution);
 
-    setUndo(true);
 
     qApp->restoreOverrideCursor();
     return true;
@@ -480,16 +469,6 @@ QPixmap KisDoc2::generatePreview(const QSize& size)
     return QPixmap(size);
 }
 
-void KisDoc2::setUndo(bool undo)
-{
-    m_d->undoAdapter->setUndo(undo);
-}
-
-bool KisDoc2::undo() const
-{
-    return m_d->undoAdapter->undo();
-}
-
 KoShapeControllerBase * KisDoc2::shapeController() const
 {
     return m_d->shapeController;
@@ -516,7 +495,6 @@ void KisDoc2::prepareForImport()
 {
     if (m_d->nserver == 0)
         init();
-    setUndo(false);
 }
 
 KisImageWSP KisDoc2::image() const
@@ -536,7 +514,6 @@ void KisDoc2::setCurrentImage(KisImageWSP image)
     m_d->shapeController->setImage(image);
     m_d->nodeModel->setImage(image);
 
-    setUndo(true);
     setModified(false);
 
     connect(m_d->image, SIGNAL(sigImageModified()), this, SLOT(setModified()));
diff --git a/krita/ui/kis_doc2.h b/krita/ui/kis_doc2.h
index 1e2cd8c..dac0952 100644
--- a/krita/ui/kis_doc2.h
+++ b/krita/ui/kis_doc2.h
@@ -93,9 +93,6 @@ public:
     /// Generate a scaled-down pixmap of the image projection that fits in size
     virtual QPixmap generatePreview(const QSize& size);
 
-    virtual void setUndo(bool undo);
-    virtual bool undo() const;
-
 public slots:
 
     /**
diff --git a/krita/ui/kis_filter_handler.cc b/krita/ui/kis_filter_handler.cc
index 78c5147..fa33673 100644
--- a/krita/ui/kis_filter_handler.cc
+++ b/krita/ui/kis_filter_handler.cc
@@ -76,7 +76,7 @@ struct KisFilterHandler::Private {
     KisPaintDeviceSP dev;
     KoProgressUpdater* updater;
     KisThreadedApplicator* applicator;
-    KisTransaction* cmd;
+    KisTransaction* transaction;
     KisSystemLocker* locker;
 };
 
@@ -91,7 +91,7 @@ KisFilterHandler::KisFilterHandler(KisFilterManager* parent, KisFilterSP f, KisV
     m_d->lastConfiguration = 0;
     m_d->updater = 0;
     m_d->applicator = 0;
-    m_d->cmd = 0;
+    m_d->transaction = 0;
     m_d->locker = 0;
 }
 
@@ -169,9 +169,7 @@ void KisFilterHandler::apply(KisNodeSP layer, KisFilterConfiguration* config)
     // also deletes all old updaters
     m_d->updater->start(100, m_d->currentFilter->name());
 
-    if (m_d->view->image()->undo()) {
-        m_d->cmd = new KisTransaction(m_d->currentFilter->name(), m_d->dev);
-    }
+    m_d->transaction = new KisTransaction(m_d->currentFilter->name(), m_d->dev);
 
     KisProcessingInformation src(m_d->dev, rect.topLeft(), selection);
     KisProcessingInformation dst(m_d->dev, rect.topLeft(), selection);
@@ -206,15 +204,13 @@ void KisFilterHandler::areaDone(const QRect & rc)
 void KisFilterHandler::filterDone(bool interrupted)
 {
     if (interrupted) {
-        if (m_d->cmd) {
-            m_d->cmd->undo();
-            delete m_d->cmd;
-        }
-
+        m_d->transaction->revert();
+        delete m_d->transaction;
     } else  {
-        if (m_d->cmd) {
-            m_d->view->document()->addCommand(m_d->cmd);
-        }
+        KisUndoAdapter *undoAdapter = m_d->view->image()->undoAdapter();
+        m_d->transaction->commit(undoAdapter);
+        delete m_d->transaction;
+
         if (m_d->filter->bookmarkManager()) {
             m_d->filter->bookmarkManager()->save(KisBookmarkedConfigurationManager::ConfigLastUsed.id(),
                                                  m_d->currentConfiguration);
diff --git a/krita/ui/kis_image_manager.cc b/krita/ui/kis_image_manager.cc
index 45d9b59..c73be6c 100644
--- a/krita/ui/kis_image_manager.cc
+++ b/krita/ui/kis_image_manager.cc
@@ -112,8 +112,6 @@ void KisImageManager::resizeCurrentImage(qint32 w, qint32 h, bool cropLayers)
     if (!m_view->image()) return;
 
     m_view->image()->resize(w, h, cropLayers);
-    m_view->image()->setModified();
-    m_view->layerManager()->layersUpdated();
 }
 
 void KisImageManager::resizeCurrentImage(qint32 w, qint32 h, qint32 xOffset, qint32 yOffset)
@@ -121,8 +119,6 @@ void KisImageManager::resizeCurrentImage(qint32 w, qint32 h, qint32 xOffset, qin
     if (!m_view->image()) return;
 
     m_view->image()->resizeWithOffset(w, h, xOffset, yOffset);
-    m_view->image()->setModified();
-    m_view->layerManager()->layersUpdated();
 }
 
 void KisImageManager::scaleCurrentImage(double sx, double sy, KisFilterStrategy *filterStrategy)
@@ -134,8 +130,6 @@ void KisImageManager::scaleCurrentImage(double sx, double sy, KisFilterStrategy
     KoUpdaterPtr up = updater->startSubtask();
 
     m_view->image()->scale(sx, sy, up, filterStrategy);
-    m_view->image()->setModified();
-    m_view->layerManager()->layersUpdated();
     updater->deleteLater();
 }
 
@@ -148,8 +142,6 @@ void KisImageManager::rotateCurrentImage(double radians)
     KoUpdaterPtr up = updater->startSubtask();
 
     m_view->image()->rotate(radians, up);
-    m_view->image()->setModified();
-    m_view->layerManager()->layersUpdated();
 
     m_view->statusBar()->progress()->detachUpdater(updater);
     updater->deleteLater();
@@ -164,8 +156,6 @@ void KisImageManager::shearCurrentImage(double angleX, double angleY)
     KoUpdaterPtr up = updater->startSubtask();
 
     m_view->image()->shear(angleX, angleY, up);
-    m_view->image()->setModified();
-    m_view->layerManager()->layersUpdated();
 
     m_view->statusBar()->progress()->detachUpdater(updater);
     updater->deleteLater();
@@ -181,8 +171,7 @@ void KisImageManager::slotImageProperties()
     KisDlgImageProperties dlg(image, m_view);
 
     if (dlg.exec() == QDialog::Accepted) {
-        QUndoCommand* cmd = new KisImagePropsCommand(image, dlg.colorSpace());
-        m_view->document()->addCommand(cmd);
+        image->convertProjectionColorSpace(dlg.colorSpace());
     }
 }
 
diff --git a/krita/ui/kis_layer_manager.cc b/krita/ui/kis_layer_manager.cc
index 52d0b92..246832e 100644
--- a/krita/ui/kis_layer_manager.cc
+++ b/krita/ui/kis_layer_manager.cc
@@ -53,7 +53,7 @@
 #include <kis_layer.h>
 #include <kis_paint_device.h>
 #include <kis_paint_layer.h>
-#include <kis_selected_transaction.h>
+#include <kis_transaction.h>
 #include <kis_selection.h>
 #include <flake/kis_shape_layer.h>
 #include <kis_shear_visitor.h>
@@ -196,20 +196,9 @@ void KisLayerManager::imageResizeToActiveLayer()
 
     if (image && (layer = activeLayer())) {
 
-        if (undoAdapter && undoAdapter->undo()) {
-            undoAdapter->beginMacro(i18n("Resize Image to Size of Current Layer"));
-        }
-
-        image->lock();
-
-        QRect r = layer->exactBounds();
-        image->resize(r.width(), r.height(), r.x(), r.y(), true);
-
-        image->unlock();
-
-        if (undoAdapter && undoAdapter->undo()) {
-            undoAdapter->endMacro();
-        }
+        undoAdapter->beginMacro(i18n("Resize Image to Size of Current Layer"));
+        image->resize(layer->exactBounds(), true);
+        undoAdapter->endMacro();
     }
 }
 
@@ -655,16 +644,12 @@ void KisLayerManager::mirrorLayerX()
     KisPaintDeviceSP dev = activeDevice();
     if (!dev) return;
 
-    KisTransaction * t = 0;
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        t = new KisTransaction(i18n("Mirror Layer X"), dev);
-        Q_CHECK_PTR(t);
-    }
+    KisTransaction transaction(i18n("Mirror Layer X"), dev);
 
     QRect dirty = KisTransformWorker::mirrorX(dev, m_view->selection());
     m_activeLayer->setDirty(dirty);
 
-    if (t) m_view->undoAdapter()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
 
     m_doc->setModified(true);
     layersUpdated();
@@ -676,16 +661,12 @@ void KisLayerManager::mirrorLayerY()
     KisPaintDeviceSP dev = activeDevice();
     if (!dev) return;
 
-    KisTransaction * t = 0;
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        t = new KisTransaction(i18n("Mirror Layer Y"), dev);
-        Q_CHECK_PTR(t);
-    }
+    KisTransaction transaction(i18n("Mirror Layer Y"), dev);
 
     QRect dirty = KisTransformWorker::mirrorY(dev, m_view->selection());
     m_activeLayer->setDirty(dirty);
 
-    if (t) m_view->undoAdapter()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
 
     m_doc->setModified(true);
     layersUpdated();
@@ -699,11 +680,7 @@ void KisLayerManager::scaleLayer(double sx, double sy, KisFilterStrategy *filter
     KisLayerSP layer = activeLayer();
     if (!layer) return;
 
-    KisSelectedTransaction * t = 0;
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        t = new KisSelectedTransaction(i18n("Scale Layer"), layer);
-        Q_CHECK_PTR(t);
-    }
+    KisSelectedTransaction transaction(i18n("Scale Layer"), layer);
 
     KoProgressUpdater* updater = m_view->createProgressUpdater();
     KoUpdaterPtr u = updater->startSubtask();
@@ -711,7 +688,8 @@ void KisLayerManager::scaleLayer(double sx, double sy, KisFilterStrategy *filter
     KisTransformWorker worker(layer->paintDevice(), sx, sy, 0, 0, 0.0, 0, 0, u, filterStrategy);
     worker.run();
 
-    if (t) m_view->undoAdapter()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
+
     m_doc->setModified(true);
     layersUpdated();
     m_view->canvas()->update();
@@ -726,9 +704,8 @@ void KisLayerManager::rotateLayer(double radians)
     KisLayerSP layer = activeLayer();
     if (!layer) return;
 
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        m_view->undoAdapter()->beginMacro(i18n("Rotate Layer"));
-    }
+    KisUndoAdapter * undoAdapter = m_view->image()->undoAdapter();
+    undoAdapter->beginMacro(i18n("Rotate Layer"));
 
     KisFilterStrategy *filter = KisFilterStrategyRegistry::instance()->value("Triangle");
     QRect r;
@@ -744,8 +721,7 @@ void KisLayerManager::rotateLayer(double radians)
     KisTransformVisitor visitor(m_view->image(), 1.0, 1.0, 0, 0, radians, -tx, -ty, 0, filter);
     layer->accept(visitor);
 
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo())
-        m_view->undoAdapter()->endMacro();
+    undoAdapter->endMacro();
 
     m_doc->setModified(true);
     layersUpdated();
@@ -759,20 +735,18 @@ void KisLayerManager::shearLayer(double angleX, double angleY)
     KisLayerSP layer = activeLayer();
     if (!layer) return;
 
-    KisUndoAdapter * undo = 0;
-    if ((undo = m_view->image()->undoAdapter())) {
-        undo->beginMacro(i18n("Shear layer"));
-    }
+    KisUndoAdapter * undoAdapter = m_view->image()->undoAdapter();
+    undoAdapter->beginMacro(i18n("Shear layer"));
 
     KoProgressUpdater* updater = m_view->statusBar()->progress()->createUpdater();
     updater->start(100, i18n("Shear layer"));
     KoUpdaterPtr up = updater->startSubtask();
 
     KisShearVisitor v(angleX, angleY, up);
-    v.setUndoAdapter(undo);
+    v.setUndoAdapter(undoAdapter);
     layer->accept(v);
 
-    if (undo) undo->endMacro();
+    undoAdapter->endMacro();
 
     m_doc->setModified(true);
     layersUpdated();
diff --git a/krita/ui/kis_mask_manager.cc b/krita/ui/kis_mask_manager.cc
index be4cdd7..4b5e576 100644
--- a/krita/ui/kis_mask_manager.cc
+++ b/krita/ui/kis_mask_manager.cc
@@ -358,16 +358,12 @@ void KisMaskManager::mirrorMaskX()
     KisPaintDeviceSP dev = m_activeMask->selection()->getOrCreatePixelSelection();
     if (!dev) return;
 
-    KisTransaction * t = 0;
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        t = new KisTransaction(i18n("Mirror Mask X"), dev);
-        Q_CHECK_PTR(t);
-    }
+    KisTransaction transaction(i18n("Mirror Mask X"), dev);
 
     QRect dirty = KisTransformWorker::mirrorX(dev, m_view->selection());
     m_activeMask->setDirty(dirty);
 
-    if (t) m_view->undoAdapter()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
 
     m_view->document()->setModified(true);
     m_activeMask->selection()->updateProjection();
@@ -384,17 +380,12 @@ void KisMaskManager::mirrorMaskY()
     KisPaintDeviceSP dev = m_activeMask->selection()->getOrCreatePixelSelection();
     if (!dev) return;
 
-    KisTransaction * t = 0;
-    if (m_view->undoAdapter() && m_view->undoAdapter()->undo()) {
-        t = new KisTransaction(i18n("Mirror Layer Y"), dev);
-        Q_CHECK_PTR(t);
-    }
+    KisTransaction transaction(i18n("Mirror Layer Y"), dev);
 
     QRect dirty = KisTransformWorker::mirrorY(dev, m_view->selection());
     m_activeMask->setDirty(dirty);
 
-
-    if (t) m_view->undoAdapter()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
 
     m_view->document()->setModified(true);
     m_activeMask->selection()->updateProjection();
